class MapVoteWRI expands WRI;

var x3dfxMapVote MapVoteMutator;
var string MapList1[257];
var string MapList2[257];
var string MapList3[257];
var string MapList4[257];
var int MapCount;
var int VoteCount, ButtonCount, MutatorLength, EnabledCount;
var string PlayerName[32];
var int PlayerCount;
var bool bKickVote;
var string MapVoteResults[100];
var string KickVoteResults[100];

var MapVoteTabWindow TabWindow;

//var bool bDM;          *
//var bool bLMS;         |*
//var bool bTDM;         ||*
//var bool bAS;          |||*
//var bool bDOM;         ||||*
//var bool bCTF;         |||||*
//var bool bOther;       ||||||*
var string GameTypes;  //0000000
var string OtherClass;
var int VoteTimeLimit;
var int KickPercent;
var bool bUseMapList;
var bool bAutoOpen;
var int  ScoreBoardDelay;
var bool bAutoDetect;
var bool bCheckOtherGameTie;
var string ServerInfoURL;
var string MapInfoURL;
var string ReportText;
var string Mode;
var int RepeatLimit;
var string MapVoteHistoryType;

var int NumVotes1,NumVotes2,NumVotes3,NumVotes4,NumVotes5,NumVotes6,NumVotes7,NumVotes8;

var bool bIsAdmin, bAllowButton1, bAllowButton2, bAllowButton3,
			bAllowButton4, bAllowButton5, bAllowButton6,
			bAllowButton7,bAllowButton8, bEnableAll, bDisableAll;
var string      ExtraMutators,
		ExtraMutators1,
		ExtraMutators2,
		ExtraMutators3,
		ExtraMutators4,
		ExtraMutators5,
		ExtraMutators6,
		ExtraMutators7,
		ExtraMutators8;

var string ButtonName1,
	ButtonName2,
	ButtonName3,
	ButtonName4,
	ButtonName5,
	ButtonName6,
	ButtonName7,
	ButtonName8;

var int MidGameVotePercent;
var int MinMapCount;
var string MapPreFixOverRide;
var string PreFixSwap;
var string OtherPreFix;
var string HasStartWindow;
var bool bEntryWindows;
var bool bSortWithPreFix;
var bool bDebugMode;
var bool b20sec;
var bool bShowVoterNames;

replication
{
   // Variables the server should send to the client.
   reliable if(Role==ROLE_Authority)
      VoteCount,ButtonCount,MutatorLength,EnabledCount,
      PlayerName,
      PlayerCount,
      MapCount,
      MapList1,MapList2,MapList3,MapList4,
      AddNewPlayer,
      RemovePlayerName,
      bKickVote,
      KickVoteResults,
      MapVoteResults,
        UpdateMapVoteResults,
        UpdateKickVoteResults,
   	UpdateModeVoteResults,
      GameTypes,
      OtherClass,
      VoteTimeLimit,
      KickPercent,
      bUseMapList,
      bAutoOpen,
      ScoreBoardDelay,
      bAutoDetect,
      bCheckOtherGameTie,
/*
      NumVotes1,
      NumVotes2,
      NumVotes3,
      NumVotes4,
      NumVotes5,
      NumVotes6,
      NumVotes7,
      NumVotes8,*/
      bAllowButton1,
      bAllowButton2,
      bAllowButton3,
      bAllowButton4,
      bAllowButton5,
      bAllowButton6,
      bAllowButton7,
      bAllowButton8, bEnableAll, bDisableAll,
		ExtraMutators,
		ExtraMutators1,
		ExtraMutators2,
		ExtraMutators3,
		ExtraMutators4,
		ExtraMutators5,
		ExtraMutators6,
		ExtraMutators7,
		ExtraMutators8,
	    ButtonName1,
		ButtonName2,
		ButtonName3,
		ButtonName4,
		ButtonName5,
		ButtonName6,
		ButtonName7,
		ButtonName8,
      ServerInfoURL,
      MapInfoURL,
      SendReportText,
      Mode,
      RepeatLimit,
      MapVoteHistoryType,
      MidGameVotePercent,
      MinMapCount,
      MapPreFixOverRide,
      PreFixSwap,
      OtherPreFix,
      HasStartWindow,
      bEntryWindows,
      bSortWithPreFix,
      bDebugMode,
      b20sec,
      bShowVoterNames;
}

simulated function bool SetupWindow ()
{
   local int i;

   // Increase the length of time messages stay on screen
   class'SayMessagePlus'.default.Lifetime     = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MsgTimeOut;
   class'CriticalStringPlus'.default.Lifetime = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MsgTimeOut;
   class'RedSayMessagePlus'.default.Lifetime  = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MsgTimeOut;
   class'TeamSayMessagePlus'.default.Lifetime = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MsgTimeOut;
   class'StringMessagePlus'.default.Lifetime  = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MsgTimeOut;
   class'DeathMessagePlus'.default.Lifetime  = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MsgTimeOut;

   //log("WRI SetupWindow");
   if ( Super.SetupWindow() )
   {
      TabWindow = MapVoteTabWindow(TheWindow);
      TabWindow.WRI = self;
      settimer(1.0,false);
   }
   else
      log("Super.SetupWindow() = false",'x3dfxMapVote');
}

simulated function Timer()
{
   local int i,MyCount,MyPlayerCount,MyVoteCount, MyButtonCount, MyMutatorLength, MyEnabledCount;;

   //count maps that have replicated
   MyCount = 0;
   i = 1;
   While(MapList1[i] != "" && i < 256)
   {
     ++MyCount;
     ++i;
   }
   i = 1;
   While(MapList2[i] != "" && i < 256)
   {
     ++MyCount;
     ++i;
   }
   i = 1;
   While(MapList3[i] != "" && i < 256)
   {
     ++MyCount;
     ++i;
   }
   i = 1;
   While(MapList4[i] != "" && i < 256)
   {
     ++MyCount;
     ++i;
   }

   //count how many PlayerNames have replicated
   While(PlayerName[MyPlayerCount++] != "");

	MyVoteCount = NumVotes1;
	MyVoteCount += NumVotes2;
	MyVoteCount += NumVotes3;
	MyVoteCount += NumVotes4;
	MyVoteCount += NumVotes5;
	MyVoteCount += NumVotes6;
	MyVoteCount += NumVotes7;
	MyVoteCount += NumVotes8;

	MyMutatorLength = Len(ExtraMutators);
	MyMutatorLength += Len(ExtraMutators1);
	MyMutatorLength += Len(ExtraMutators2);
	MyMutatorLength += Len(ExtraMutators3);
	MyMutatorLength += Len(ExtraMutators4);
	MyMutatorLength += Len(ExtraMutators5);
	MyMutatorLength += Len(ExtraMutators6);
	MyMutatorLength += Len(ExtraMutators7);
	MyMutatorLength += Len(ExtraMutators8);

	MyButtonCount = Len(ButtonName1);
	MyButtonCount += Len(ButtonName2);
	MyButtonCount += Len(ButtonName3);
	MyButtonCount += Len(ButtonName4);
	MyButtonCount += Len(ButtonName5);
	MyButtonCount += Len(ButtonName6);
	MyButtonCount += Len(ButtonName7);
	MyButtonCount += Len(ButtonName8);

	MyEnabledCount = int(bAllowButton1);
	MyEnabledCount += int(bAllowButton2);
	MyEnabledCount += int(bAllowButton3);
	MyEnabledCount += int(bAllowButton4);
	MyEnabledCount += int(bAllowButton5);
	MyEnabledCount += int(bAllowButton6);
	MyEnabledCount += int(bAllowButton7);
	MyEnabledCount += int(bAllowButton8);
	MyEnabledCount += int(bEnableAll);
	MyEnabledCount += int(bDisableAll);

	//log("Wating on replicated info.. Maps: (" $(MyCount < MapCount) $ ") Players: (" $ (MyPlayerCount < PlayerCount) $ ") Vote Counts: (" $ (MyVoteCount < VoteCount) $ ") Button Names: (" $ (MyButtonCount < ButtonCount) $ ") Mutators: (" $ (MyMutatorLength < MutatorLength) $ ") Enabled Buttons: (" $ (MyEnabledCount < EnabledCount) $")", 'x3dfxMapVote');
   if((MyEnabledCount < EnabledCount) || (MyCount < MapCount) || (MyPlayerCount < PlayerCount) || (MyVoteCount < VoteCount) || (MyButtonCount < ButtonCount) || (MyMutatorLength < MutatorLength))
   {
      //log("settimer");
      settimer(0.5,false);
      return;
   }

   log("Total Maps Received = "$ MyCount,'x3dfxMapVote');

   if(MapCount > 0)
   {
      // fill Map List-Box with map names
      //  Map Number  List
      //  ----------- ----------
      //  1   - 255   MapList1
      //  256 - 510   MapList2
      //  511 - 765   MapList3
      //  766 - 1020  MapList4

      for(i=1; i<=MapCount; ++i)
      {
	 if(i < 256)
	   TabWindow.AddMapName(MapList1[i]);
	 else if(i >= 256 && i < 511)
	   TabWindow.AddMapName(MapList2[i - 255]);
	 else if(i >= 511 && i < 766)
	   TabWindow.AddMapName(MapList3[i - 510]);
	 else if(i >= 766)
	   TabWindow.AddMapName(MapList4[i - 765]);
      }

      if(Mid(GameTypes,6,1) == "1")
      {
	 TabWindow.MapWindow.PreFixSwap = PreFixSwap;
	 TabWindow.MapWindow.MapPreFixOverRide = MapPreFixOverRide;
	 TabWindow.MapWindow.OtherPreFix = OtherPreFix;
      }

      // fill player list-box with player names
      if(bKickVote)
      {
	 //log("EnableKickWindow");
	 TabWindow.EnableKickWindow();
	 for(i=0; i<PlayerCount; ++i)
	    TabWindow.AddPlayerName(PlayerName[i]);
      }

      i=0;
      while(MapVoteResults[i] != "" && i<99)
      {
	 //TabWindow.MapVoteResults[i] = MapVoteResults[i];
	 UpdateMapVoteResults(MapVoteResults[i],i);
	 ++i;
      }
      i=0;
      while(KickVoteResults[i] != "" && i<99)
      {
	 //TabWindow.KickVoteResults[i] = KickVoteResults[i];
	 UpdateKickVoteResults(KickVoteResults[i],i);
	 ++i;
      }

      if(TabWindow.AdminWindow != none)
      {
	TabWindow.UpdateAdmin(GameTypes,
					      OtherClass,
					      VoteTimeLimit,
					      KickPercent,
					      ScoreBoardDelay,
					      bUseMapList,
					      bAutoOpen,
					      bKickVote,
					      bAutoDetect,
					      bCheckOtherGameTie,
					      RepeatLimit,
					      MapVoteHistoryType,
					      MidGameVotePercent,
					      Mode,
					      MinMapCount,
					      MapPreFixOverRide);

	 AdminWindow(TabWindow.AdminWindow.ClientArea).cboHasStartWindow.SetValue(HasStartWindow);
	 AdminWindow(TabWindow.AdminWindow.ClientArea).txtMapInfoURL.SetValue(MapInfoURL);
	 AdminWindow(TabWindow.AdminWindow.ClientArea).cbEntryWindows.bChecked = bEntryWindows;
	 AdminWindow(TabWindow.AdminWindow.ClientArea).cbSortWithPreFix.bChecked = bSortWithPreFix;
	 AdminWindow(TabWindow.AdminWindow.ClientArea).txtPreFixSwap.SetValue(PreFixSwap);
	 AdminWindow(TabWindow.AdminWindow.ClientArea).cbDebugMode.bChecked = bDebugMode;
	 AdminWindow(TabWindow.AdminWindow.ClientArea).cb20sec.bChecked = b20sec;
	 AdminWindow(TabWindow.AdminWindow.ClientArea).cbShowVoterNames.bChecked = bShowVoterNames;
      }

	if (TabWindow.GameTypesWindow != None)
	{

	TabWindow.UpdateGameTypes(bEnableAll, bDisableAll);

	TabWindow.UpdateExtraMutators(ExtraMutators, ExtraMutators1, ExtraMutators2, ExtraMutators3,
			ExtraMutators4, ExtraMutators5, ExtraMutators6, ExtraMutators7,
			ExtraMutators8);
	}

      // bonehed316: update the tab window
      TabWindow.UpdateModeVoteResults(NumVotes1,NumVotes2,NumVotes3,NumVotes4,NumVotes5,
			NumVotes6,NumVotes7,NumVotes8);

	//bonehed316: update the button names
      TabWindow.UpdateModeVoteButtons(bAllowButton1,bAllowButton2,bAllowButton3,bAllowButton4,
      			bAllowButton5,bAllowButton6,bAllowButton7,bAllowButton8);
      TabWindow.UpdateButtonNames(ButtonName1, ButtonName2, ButtonName3, ButtonName4,
      			ButtonName5, ButtonName6, ButtonName7, ButtonName8);


      TabWindow.MapWindow.lblMapCount.SetText(MapCount $ " Maps");
      TabWindow.MapWindow.lblMode.SetText("Mode: " $ Mode);

      if(ServerInfoURL != "")
      {
	 //TabWindow.InfoWindow.SetInfoServerAddress(InfoServerAddress, InfoServerPort, InfoFilePath, ServerInfoFile);
	 TabWindow.InfoWindow.SetInfoServerAddress(ServerInfoURL, MapInfoURL);
	 if(TabWindow.AdminWindow != none)
	    AdminWindow(TabWindow.AdminWindow.ClientArea).txtServerInfoURL.SetValue(ServerInfoURL);
      }
      else
	 MapVoteNavBar(TabWindow.InfoWindow.VSplitter.BottomClientWindow).ServerInfoButton.bDisabled = true;

      // Enable the Report buttons
      MapVoteNavBar(TabWindow.InfoWindow.VSplitter.BottomClientWindow).ReportButton1.bDisabled = false;
      MapVoteNavBar(TabWindow.InfoWindow.VSplitter.BottomClientWindow).ReportButton2.bDisabled = false;

      if(MapInfoURL == "")
      {
	 TabWindow.MapWindow.InfoButton.bDisabled = true;
	 MapVoteNavBar(TabWindow.InfoWindow.VSplitter.BottomClientWindow).MapInfoButton.bDisabled = true;
      }
   }
}

function GetServerConfig() // executes on server
{
   GameTypes = GameTypes $ int(class'x3dfxMapVotev25e.x3dfxMapVote'.default.bDM);
   GameTypes = GameTypes $ int(class'x3dfxMapVotev25e.x3dfxMapVote'.default.bLMS);
   GameTypes = GameTypes $ int(class'x3dfxMapVotev25e.x3dfxMapVote'.default.bTDM);
   GameTypes = GameTypes $ int(class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAS);
   GameTypes = GameTypes $ int(class'x3dfxMapVotev25e.x3dfxMapVote'.default.bDOM);
   GameTypes = GameTypes $ int(class'x3dfxMapVotev25e.x3dfxMapVote'.default.bCTF);
   GameTypes = GameTypes $ int(class'x3dfxMapVotev25e.x3dfxMapVote'.default.bOther);

   OtherClass = class'x3dfxMapVotev25e.x3dfxMapVote'.default.OtherClass;
   VoteTimeLimit = class'x3dfxMapVotev25e.x3dfxMapVote'.default.VoteTimeLimit;
   KickPercent = class'x3dfxMapVotev25e.x3dfxMapVote'.default.KickPercent;
   bUseMapList = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bUseMapList;
   bAutoOpen = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAutoOpen;
   bKickVote = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bKickVote;
   ScoreBoardDelay = class'x3dfxMapVotev25e.x3dfxMapVote'.default.ScoreBoardDelay;
   bAutoDetect = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAutoDetect;
   bCheckOtherGameTie = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bCheckOtherGameTie;
   ServerInfoURL = class'x3dfxMapVotev25e.x3dfxMapVote'.default.ServerInfoURL;
   MapInfoURL = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MapInfoURL;
   Mode = class'x3dfxMapVotev25e.x3dfxMapVote'.default.Mode;
   RepeatLimit = class'x3dfxMapVotev25e.x3dfxMapVote'.default.RepeatLimit;
   MapVoteHistoryType = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MapVoteHistoryType;
   MidGameVotePercent = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MidGameVotePercent;
   MinMapCount = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MinMapCount;
   MapPreFixOverRide = class'x3dfxMapVotev25e.x3dfxMapVote'.default.MapPreFixOverRide;
   HasStartWindow = class'x3dfxMapVotev25e.x3dfxMapVote'.default.HasStartWindow;
   bEntryWindows = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bEntryWindows;
   PreFixSwap = class'x3dfxMapVotev25e.x3dfxMapVote'.default.PreFixSwap;
   if(MapVoteMutator.OtherGameClass != None)
	OtherPreFix = MapVoteMutator.OtherGameClass.default.MapPreFix;
   bSortWithPreFix = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bSortWithPreFix;
   bDebugMode = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bDebugMode;
   b20sec = class'x3dfxMapVotev25e.x3dfxMapVote'.default.b20SecOpenVoteWindow;
   bShowVoterNames = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bShowVoterNames;

	// get button info from mutator (might not be needed serverside)
   bAllowButton1 = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAllowButton1;
   bAllowButton2 = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAllowButton2;
   bAllowButton3 = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAllowButton3;
   bAllowButton4 = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAllowButton4;
   bAllowButton5 = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAllowButton5;
   bAllowButton6 = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAllowButton6;
   bAllowButton7 = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAllowButton7;
   bAllowButton8 = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bAllowButton8;
   bEnableAll = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bEnableAll;
   bDisableAll = class'x3dfxMapVotev25e.x3dfxMapVote'.default.bDisableAll;
}
//-------------------------------------------------------------------
simulated function AddNewPlayer(string NewPlayerName)   // executes on client
{
   if(bKickVote)
      TabWindow.AddPlayerName(NewPlayerName);
}
//-------------------------------------------------------------------
simulated function RemovePlayerName(string OldPlayerName)   // executes on client
{
   if(bKickVote)
      TabWindow.RemovePlayerName(OldPlayerName);
}
//-------------------------------------------------------------------
simulated function UpdateMapVoteResults(string Text,int i)
{
	TabWindow.UpdateMapVoteResults(Text, i);
}
//-------------------------------------------------------------------
// bonehed316:  replicate the modevote items

simulated function UpdateModeVoteResults(int b1,int b2,int b3,int b4,int b5,int b6,int b7,int b8)
{
	NumVotes1=b1;
	NumVotes2=b2;
	NumVotes3=b3;
	NumVotes4=b4;
	NumVotes5=b5;
	NumVotes6=b6;
	NumVotes7=b7;
	NumVotes8=b8;
	if (TabWindow != None)
		TabWindow.UpdateModeVoteResults(b1,b2,b3,b4,b5,b6,b7,b8);
}

//-------------------------------------------------------------------
simulated function UpdateKickVoteResults(string Text,int i)
{
   TabWindow.UpdateKickVoteResults(Text, i);
}

simulated function SendReportText(string p_ReportText)
{
   if(p_ReportText == "")
   {
      TabWindow.InfoWindow.SetMOTD(ReportText);
      ReportText = "";
   }
   else
      ReportText = ReportText $ p_ReportText;
}

defaultproperties
{
	NumVotes1=-1	// hack to stop vote count from passing when 0 and un-replicated


     WindowClass=Class'x3dfxMapVotev25e.MapVoteTabWindow'
     NetPriority=4.000000
     WinLeft=50
     WinTop=30
     WinWidth=610
     WinHeight=330
}
